> ## Documentation Index
> Fetch the complete documentation index at: https://docs.range.org/llms.txt
> Use this file to discover all available pages before exploring further.

# Simulate Cosmos Transaction

> Simulate a Cosmos-based transaction to analyze effects and risks before broadcasting.


The Cosmos Transaction Simulator supports simulation of transactions across Cosmos SDK-based networks including Osmosis and Neutron, providing the same detailed analysis available for Solana, instruction parsing, balance changes, state predictions, and risk assessment.

For Cosmos-based addresses, use the [Address Risk Score](/risk-api/risk/get-address-risk-score) endpoint to check risk levels before transacting. Supported Cosmos networks include `osmosis-1`, `cosmoshub-4`, `dydx-mainnet-1`, `neutron-1`, `celestia`, and [more](/risk-api/risk/get-address-risk-score#supported-networks).

[Contact us](https://www.range.org/get-in-touch) for early access or updates on availability.


## OpenAPI

````yaml post /v1/simulate/{network}/transaction
openapi: 3.0.0
info:
  title: Range Risk API
  description: The Range Risk API for risk assessment of crypto addresses.
  version: 1.7.9
  contact: {}
servers:
  - url: https://api.range.org
    description: Range API Server
security:
  - Authorization: []
tags:
  - name: Risk
    description: Get risk information about a crypto address.
  - name: Risk v2
    description: >-
      Address risk assessment, workspace configuration, and signals catalogue
      (API v2).
  - name: Simulator
    description: Simulate a transaction on a network.
  - name: Alert Templates
    description: Browse alert rule templates available to the workspace.
  - name: Alert Rules
    description: Create and manage workspace alert rules.
  - name: Alert Events
    description: List and retrieve fired alert events.
  - name: Channels
    description: Configure alert delivery channels.
paths:
  /v1/simulate/{network}/transaction:
    post:
      tags:
        - Simulator
      summary: Simulate Cosmos Transaction
      description: >-
        Simulate a Cosmos SDK based blockchain transaction to get the address
        balance changes after the transaction is executed.
      operationId: simulateTx
      parameters:
        - name: network
          required: true
          in: path
          description: The network to simulate the transaction on
          schema:
            enum:
              - osmosis-1
              - neutron-1
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SimulateTxDto'
      responses:
        '200':
          description: Simulated transaction result
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SimulatedTx'
components:
  schemas:
    SimulateTxDto:
      type: object
      properties:
        tx:
          type: string
          minLength: 1
          description: Keplr transaction or Base64 encoded raw transaction
          example: >-
            CoEECv4DCh0vY29zbW9zLmF1dGh6LnYxYmV0YTEuTXNnRXhlYxLcAworb3NtbzE3OW50bGM3c2gyZGFkc2F0ZjdoNGd6ZHkzand2cTQ3NWE3ZWN0NxKsAwoxL29zbW9zaXMucG9vbG1hbmFnZXIudjFiZXRhMS5Nc2dTd2FwRXhhY3RBbW91bnRJbhL2Agorb3NtbzFkbGRyeHo1cDh1ZXp4ejNxc3RwdjkyZGU3d2dmcDdodnI3MmRjbRJJCOMLEkRpYmMvMTc4MjQ4QzI2MkRFMkUxNDFFRTYyODdFRTdBQjA4NTRGMDVGMjVCMEEzRjQwQzRCOTEyRkExQzdFNTFGNDY2RRIKCJQNEgV1b3NtbxJJCLgLEkRpYmMvNDk4QTA3NTFDNzk4QTBEOUEzODlBQTM2OTExMjNEQURBNTdEQUE0RkUxNjVENUM3NTg5NDUwNUI4NzZCQTZFNBJJCMcJEkRpYmMvRDE4OTMzNUM2RTRBNjhCNTEzQzEwQUIyMjdCRjFDMUQzOEM3NDY3NjYyNzhCQTNFRUI0RkIxNDEyNEYxRDg1OBpQCkRpYmMvNDk4QTA3NTFDNzk4QTBEOUEzODlBQTM2OTExMjNEQURBNTdEQUE0RkUxNjVENUM3NTg5NDUwNUI4NzZCQTZFNBIINTMwNzIzNTUiCDUzMDcyMzU1EmkKUgpGCh8vY29zbW9zLmNyeXB0by5zZWNwMjU2azEuUHViS2V5EiMKIQI44AflBFsxuMDrOXsYpll6ZdyZB4hvIgVmAV9y7inkcBIECgIIARiH4B0SEwoNCgV1b3NtbxIENDM3NhDw52oaQNcdpT1IJzCdk1gfBY3z7r+ArcRMHtCJrxf5J0O3B8suIti4rDlIWpedzw0GoJx/VQvaM6ZT44Fh8bMh9O6IWBw=
      required:
        - tx
    SimulatedTx:
      type: object
      properties:
        addresses:
          type: array
          items:
            type: object
        gas_info:
          $ref: '#/components/schemas/GasInfo'
      required:
        - addresses
        - gas_info
    GasInfo:
      type: object
      properties:
        gas_wanted:
          type: string
        gas_used:
          type: string
      required:
        - gas_wanted
        - gas_used
  securitySchemes:
    Authorization:
      scheme: bearer
      bearerFormat: API Key
      description: 'Use Authorization: Bearer <api-key>'
      type: http

````